/******************************************************************
*******************************************************************
***																***
***		Common definitions  									***
***																***
*******************************************************************
******************************************************************/

/******************************************************************
***																***
***		Common definitions  									***
***																***
******************************************************************/

// If defined, open NUL instead of NULL device
#define OPEN_NUL_INSTEAD

/******************************************************************
***																***
***		Global functions/variables exported from lernel32.cpp   ***
***																***
******************************************************************/

								/*************************************/
								/**	global functions				**/
								/*************************************/
extern void DebugPrintF( const char* pszFormat,... ) ;
extern void DebugPrintBytes( const void* pData, DWORD dBytes ) ;
								/*************************************/
								/**	global variables				**/
								/*************************************/
extern HMODULE hThis ;
extern HMODULE hOriginal ;
extern char szAppPath[] ;
								/*************************************/
								/**	pointer to original API 		**/
								/*************************************/
#ifndef FROM_LERNEL_CPP
extern "C" {
	extern HANDLE (WINAPI *p_CreateFileA)(
		LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
		LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
		DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ) ;
	extern HANDLE (WINAPI *p_CreateFileW)(
		LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
		LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
		DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ) ;
	extern BOOL (WINAPI *p_CloseHandle)(
		HANDLE hObject ) ;
	extern BOOL (WINAPI *p_DeviceIoControl)(
		HANDLE hDevice, DWORD dwIoControlCode,
		LPVOID lpInBuffer, DWORD nInBufferSize,
		LPVOID lpOutBuffer, DWORD nOutBufferSize, LPDWORD lpBytesReturned,
		LPOVERLAPPED lpOverlapped ) ;
	extern BOOL (WINAPI *p_CancelIo)(
		HANDLE hFile ) ;
	extern BOOL (WINAPI *p_GetOverlappedResult)(
		HANDLE hFile, LPOVERLAPPED lpOverlapped,
		LPDWORD lpNumberOfBytesTransferred, BOOL bWait ) ;
}
#endif

/******************************************************************
***																***
***		Global functions/variables exported by HookedAPIs.cpp   ***
***																***
******************************************************************/

								/*************************************/
								/**	global functions				**/
								/*************************************/
extern BOOL SetupHook( void ) ;
extern void CleanupHook( void ) ;
								/*************************************/
								/**	hooked function 				**/
								/*************************************/
extern "C" {
	extern HANDLE WINAPI d_CreateFileA(
		LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
		LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
		DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ) ;
	extern HANDLE WINAPI d_CreateFileW(
		LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode,
		LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition,
		DWORD dwFlagsAndAttributes, HANDLE hTemplateFile ) ;
	extern BOOL WINAPI d_CloseHandle(
		HANDLE hObject ) ;
	extern BOOL WINAPI d_DeviceIoControl(
		HANDLE hDevice, DWORD dwIoControlCode,
		LPVOID lpInBuffer, DWORD nInBufferSize,
		LPVOID lpOutBuffer, DWORD nOutBufferSize, LPDWORD lpBytesReturned,
		LPOVERLAPPED lpOverlapped ) ;
	extern BOOL WINAPI d_CancelIo(
		HANDLE hFile ) ;
	extern BOOL WINAPI d_GetOverlappedResult(
		HANDLE hFile, LPOVERLAPPED lpOverlapped,
		LPDWORD lpNumberOfBytesTransferred, BOOL bWait ) ;
}

/******************************************************************
***																***
***		Global functions/variables exported by Application.cpp  ***
***																***
******************************************************************/

								/*************************************/
								/**	global functions				**/
								/*************************************/
extern BOOL SetupApp( void ) ;
extern void CleanupApp( void ) ;
extern BOOL IsTargetDevice( LPCSTR lpFileName ) ;
extern void TargetOpened( HANDLE hDevice ) ;
extern void TargetClosed( void ) ;
								/*************************************/
								/**	override function   			**/
								/*************************************/
extern BOOL OrDeviceIoControl( BOOL& bRet,
	HANDLE& hDevice, DWORD& dwIoControlCode,
	LPVOID& lpInBuffer, DWORD& nInBufferSize,
	LPVOID& lpOutBuffer, DWORD& nOutBufferSize, LPDWORD& lpBytesReturned,
	LPOVERLAPPED& lpOverlapped ) ;
extern BOOL OrCancelIo( BOOL& bRet,
	HANDLE& hFile ) ;
extern BOOL OrGetOverlappedResult( BOOL& bRet,
	HANDLE& hFile, LPOVERLAPPED& lpOverlapped,
	LPDWORD& lpNumberOfBytesTransferred, BOOL& bWait ) ;

